define('aim/absence/view/BoardMainView',['aim/absence/model/ChangePlanValueModel','aim/absence/view/SelectCalendarWeekView'], function(ChangePlanValueModel,SelectCalendarWeekView) {
	var BoardMainView = Backbone.View.extend({
		el : "#content",
		
		events: {
			"click #dialog-add-absence-button" : "addAbsenceValues",
			"click #calendar-weeks-shift-left-button" : "calendarWeeksShiftLeft",
			"click #calendar-weeks-shift-right-button" : "calendarWeeksShiftRight",
			"change .inputweeks" : "edit",
			"change #calendar-week-select" : "jumpToCalendarWeek"
		},
		
		context : {},
		
		initialize : function() {
			var requests = new Array();
			AJS.$.ajaxSetup({
				beforeSend:function(event,xhr,options){
					requests.push(xhr);
					if(xhr.url.endsWith("/context") ){
						AJS.$('.spinner').spin();
						AJS.$('.spinner').addClass('naomi-spinner');
					}
				},
				complete:function(xhr,status){
					requests.pop(xhr);
					if(requests.length == 0){
						AJS.$('.spinner').spinStop();
						AJS.$('.spinner').removeClass('naomi-spinner');
					}
				}
			});	
			this.listenTo(this.model, 'sync', this.render);
			var selectCalendarWeekView = new SelectCalendarWeekView({model: this.model});
			this.model.fetch();
		},
		
		render : function() {
			focusedElementId = AJS.$(':focus').attr('id');
			var tmpOps = {};
			tmpOps.isResourceMode = this.context.mode == constants.resourceMode ? true : false;
			tmpOps.currentWeek = this.model.get('highlightedWeek');
			var pagePanelInner = this.$('#aui-page-panel-inner');
			pagePanelInner.html(Naomi.Templates.AbsenceBoard.board(tmpOps, null, this.model.get('context')));
		    AJS.$('#' + focusedElementId).focus();
		    AJS.$('#' + focusedElementId).select();
		    return this;
		},
			
		addAbsenceValues : function() {
//			AJS.$("#select2-example").auiSelect2();
//			AJS.dialog2("#demo-dialog").show();
//			AJS.$("#resource-single-select").auiSelect2();
			AJS.dialog2("#add-absence-dialog").show();
		},
		
		calendarWeeksShiftLeft : function() {
			this.model.set("calendarWeekShift",-1);
			this.model.set("calendarWeekShiftChanged","true");
			this.model.save();
		},
		
		calendarWeeksShiftRight : function() {
			this.model.set("calendarWeekShift",1);
			this.model.set("calendarWeekShiftChanged","true");
			this.model.save();
		},
		
		jumpToCalendarWeek : function(event) {
			this.model.set("calendarWeekShift",event.currentTarget.value);
			this.model.set("calendarWeekShiftChanged","true");
			this.model.save();
		},
		
		edit: function(event) {
			var that = this;
			if(event && event.currentTarget && event.currentTarget.id) {
				if(!event.currentTarget.value) return;
				var ids = event.currentTarget.id.split("-");
				if(ids && ids.length == 3) {
					var weekId = null;
					var userId = null;
					_.each(ids, function(id, index) {
						switch(index) {
					    case 1:
					        weekId = id;
					        break;
					    case 2:
					        userId = id;
					        break;
						}
					});
					console.log("editing week: " + weekId + " userId: " + userId);
					var weeks = this.model.attributes.context.weeks;
					var selectedWeek;
					_.each( weeks, function( week ) {
					  if ( week.title == weekId ) {
						  selectedWeek=week;
					  }
					});

					var modelForSave = new ChangePlanValueModel();
					modelForSave.set('selectedResource', userId);
					//TODO add the current year to the context...
					modelForSave.set('year', selectedWeek.year);
					modelForSave.set('week', weekId);
					modelForSave.set('operation', "spreadInWeek");
					modelForSave.set('planValue', event.currentTarget.value);
					modelForSave.save(null, {success:function(model, res, options) {
						var context = that.model.get("context");
						var result = res;
						var kw = _.find(context.weeks, function(week) {
							if(week.title == weekId) {
								return true;
							} else {
								return false;
							}
						}); 
						
						var restSum = result.resourceRestSum;
						var inputValue = result.planValue;

						kw.resourceSubSections[userId].sectionValues[userId].sum = inputValue;
//						kw.resourceSubSections[userId].sectionValues[userId].restSum = restSum;
						that.render();
					}});	

				}
			}
		}
	});
	return BoardMainView;
});